/*
 * Parse slash-delimited book data.
 */
%%

%class lex

%standalone

%unicode

LineTerminator = \r|\n|\r\n
Slash = "/"
Field = [^/\r\n]+

%{

   StringBuffer line = new StringBuffer();

   private void add_to_buffer(String s) {
       line.append(s);
   }

   private void display_line() {
       System.out.println(line.toString());
       line = new StringBuffer();  /* Clear buffer */
   }
%}

%%

{Field}            { add_to_buffer(yytext()); }

{Slash}            { add_to_buffer("/"); }

{LineTerminator}   { display_line(); }

<<EOF>>            { return 0; }
