/*
 * Parse slash-delimited book data.
 */
%%

%class lex

%standalone

%unicode

%line
%column
%char

LineTerminator = \r|\n|\r\n
Slash = "/"
Field = [^/\r\n]+
Title = \"[^/\r\n]+\"

%{

   private void print_start_tag(String s) {
       System.out.print("<" + s + ">");
   }

   private void print_element_data(String s) {
       System.out.print(s);
   }

   private void print_end_tag(String s) {
       System.out.print("</" + s + ">");
   }

   private void print_new_line() {
       System.out.println();
   }
%}

%%

{Title}            { print_start_tag("Title"); 
                     print_element_data(yytext());
                     print_end_tag("Title");
                   }

{Field}            { print_start_tag("Field"); 
                     print_element_data(yytext());
                     print_end_tag("Field");
                   }

{Slash}            { print_new_line(); }

{LineTerminator}   { print_new_line(); }

<<EOF>>            { return 0; }
