import java_cup.runtime.*;

%%

%class lex
%cup

%standalone

%unicode

%state TITLE, AUTHOR, DATE, ISBN, PUBLISHER

LineTerminator = \r|\n|\r\n
Slash = "/"
Field = [^/\r\n]+
Title = \"{Field}\"
Char  = .

%%

<YYINITIAL> {

    {Char}              { yypushback(1);
                          yybegin(TITLE);
                        }
}

<TITLE> {

    {Title}             { return new Symbol(sym.TITLE, yytext()); }

    {Slash}             { yybegin(AUTHOR);
                          return new Symbol(sym.SLASH);
                        }

    <<EOF>>             { return new Symbol(sym.EOF); }

}

<AUTHOR> {

    {Field}             { return new Symbol(sym.AUTHOR, yytext()); }

    {Slash}             { yybegin(DATE);
                          return new Symbol(sym.SLASH);
                        }

}

<DATE> {

    {Field}             { return new Symbol(sym.DATE, yytext()); }

    {Slash}             { yybegin(ISBN);
                          return new Symbol(sym.SLASH);
                        }

}

<ISBN> {

    {Field}             { return new Symbol(sym.ISBN, yytext()); }

    {Slash}             { yybegin(PUBLISHER);
                          return new Symbol(sym.SLASH);
                        }

}

<PUBLISHER> {

    {Field}             { return new Symbol(sym.PUBLISHER, yytext()); }

    {LineTerminator}    { yybegin(TITLE);
                          return new Symbol(sym.EOL);
                        }
}