%%

%class lex

%standalone

%unicode

LineTerminator = \r|\n|\r\n
XML_Declaration = "<?xml version="[\"']"1.0"[\"'][^\r\n]*"?>"{LineTerminator}
DOCTYPE_Declaration = "<!DOCTYPE "[^\r\n]+">"{LineTerminator}
Name = [^</>]+
StartTag = "<"{Name}">"
EndTag = "</"{Name}">"
PCDATA = [a-zA-Z& \n\r\t]+
Whitespace = [\n\r\t ]+

%%

{XML_Declaration}       { System.out.println("XML_DECLARATION = " + yytext()); }

{DOCTYPE_Declaration}   { System.out.println("DOCTYPE_Declaration = " + yytext()); }

{StartTag}              { String token = yytext();
                          if (token.equals("BookCatalogue")) System.out.println("It's BookCatalogue!");
                          System.out.println("StartTag = " + yytext()); }

{EndTag}                { System.out.println("EndTag = " + yytext()); }

{Whitespace}            { System.out.println("Whitespace = #" + yytext() + "#"); }

{PCDATA}                { System.out.println("PCDATA = #" + yytext() + "#"); }

<<EOF>>                 { return 0; }

