/*
 * Parse newline-delimited juicer data.
 */
%%

%class lex

%standalone

%unicode

%%

"Juicer:"                  { System.out.println("<juicer>"); }

"name = "[^\r\n]*         { System.out.println("<name>" + yytext() + "</name>"); }

"type = "[^\r\n]*         { System.out.println("<type>" + yytext() + "</type>"); }

"image = "[^\r\n]*        { System.out.println("<image>" + yytext() + "</image>"); }

"description = "[^\r\n]*  { System.out.println("<description>" + yytext() + "</description>"); }

"warranty = "[^\r\n]*     { System.out.println("<warranty>" + yytext() + "</warranty>"); }

"weight(lbs) = "[^\r\n]*  { System.out.println("<weight units='lbs'>" + yytext() + "</weight>"); }

"cost(USD) = "[^\r\n]*    { System.out.println("<cost currency='USD'>" + yytext() + "</cost>"); }

"retailer = "[^\r\n]*     { System.out.println("<retailer>" + yytext() + "</retailer>"); }

[-]+                       { System.out.println("</juicer>"); }

\r|\n|\r\n                 { ; /* Do nothing */}

<<EOF>>                    { return 0; }
