/*
 * Parse newline-delimited juicer data.
 */
%%

%class lex

%standalone

%unicode

%%

"Juicer:"                  { System.out.println("<juicer>"); }

"name = "[^\r\n]*         { String token = yytext();
                            String qualifier = "name = ";
                            String data = token.substring(qualifier.length());
                            System.out.println("<name>" + data + "</name>"); 
                          }

"type = "[^\r\n]*         { String token = yytext();
                            String qualifier = "type = ";
                            String data = token.substring(qualifier.length());
                            System.out.println("<type>" + data + "</type>"); 
                          }

"image = "[^\r\n]*        { String token = yytext();
                            String qualifier = "image = ";
                            String data = token.substring(qualifier.length());
                            System.out.println("<image>" + data + "</image>"); 
                          }

"description = "[^\r\n]*  { String token = yytext();
                            String qualifier = "description = ";
                            String data = token.substring(qualifier.length());
                            System.out.println("<description>" + data + "</description>"); 
                          }

"warranty = "[^\r\n]*     { String token = yytext();
                            String qualifier = "warranty = ";
                            String data = token.substring(qualifier.length());
                            System.out.println("<warranty>" + data + "</warranty>"); 
                          }

"weight(lbs) = "[^\r\n]*  { String token = yytext();
                            String qualifier = "weight(lbs) = ";
                            String data = token.substring(qualifier.length());
                            System.out.println("<weight units='lbs'>" + data + "</weight>"); 
                          }

"cost(USD) = "[^\r\n]*    { String token = yytext();
                            String qualifier = "cost(USD) = ";
                            String data = token.substring(qualifier.length());
                            System.out.println("<cost currency='USD'>" + data + "</cost>"); 
                          }

"retailer = "[^\r\n]*     { String token = yytext();
                            String qualifier = "retailer = ";
                            String data = token.substring(qualifier.length());
                            System.out.println("<retailer>" + data + "</retailer>"); 
                          }

[-]+                       { System.out.println("</juicer>"); }

\r|\n|\r\n                 { ; /* Do nothing */}

<<EOF>>                    { return 0; }
