/*
 * Parse newline-delimited juicer data.
 */
%%

%class lex

%standalone

%unicode

juicer = "Juicer:"
name = "name = "[^\r\n]*
type = "type = "[^\r\n]*
image = "image = "[^\r\n]*
description = "description = "[^\r\n]*
warranty = "warranty = "[^\r\n]*
weight = "weight(lbs) = "[^\r\n]*
cost = "cost(USD) = "[^\r\n]*
retailer = "retailer = "[^\r\n]*

%%

{juicer}                  { System.out.println("<juicer>"); }

{name}                    { String token = yytext();
                            String qualifier = "name = ";
                            String data = token.substring(qualifier.length());
                            System.out.println("<name>" + data + "</name>"); 
                          }

{type}                    { String token = yytext();
                            String qualifier = "type = ";
                            String data = token.substring(qualifier.length());
                            System.out.println("<type>" + data + "</type>"); 
                          }

{image}                   { String token = yytext();
                            String qualifier = "image = ";
                            String data = token.substring(qualifier.length());
                            System.out.println("<image>" + data + "</image>"); 
                          }

{description}             { String token = yytext();
                            String qualifier = "description = ";
                            String data = token.substring(qualifier.length());
                            System.out.println("<description>" + data + "</description>"); 
                          }

{warranty}                { String token = yytext();
                            String qualifier = "warranty = ";
                            String data = token.substring(qualifier.length());
                            System.out.println("<warranty>" + data + "</warranty>"); 
                          }

{weight}                  { String token = yytext();
                            String qualifier = "weight(lbs) = ";
                            String data = token.substring(qualifier.length());
                            System.out.println("<weight units='lbs'>" + data + "</weight>"); 
                          }

{cost}                    { String token = yytext();
                            String qualifier = "cost(USD) = ";
                            String data = token.substring(qualifier.length());
                            System.out.println("<cost currency='USD'>" + data + "</cost>"); 
                          }

{retailer}                { String token = yytext();
                            String qualifier = "retailer = ";
                            String data = token.substring(qualifier.length());
                            System.out.println("<retailer>" + data + "</retailer>"); 
                          }

[-]+                      { System.out.println("</juicer>"); }

\r|\n|\r\n                { ; /* Do nothing */}

<<EOF>>                   { return 0; }
