/*
 * Parse newline-delimited juicer data.
 */
%%

%class lex

%standalone

%unicode

%line

%state NAME, TYPE, IMAGE, DESCRIPTION, WARRANTY, WEIGHT, COST, RETAILER

char = [^\r\n]
name = {char}*
type = {char}*
image = {char}*
description = {char}*
warranty = {char}*
weight = {char}*
cost = {char}*
retailer = {char}*
eol = \r|\n|\r\n

%%

<YYINITIAL> {

    {char}              { System.out.print("<?xml version='1.0'?>");
                          System.out.println("<juicers>");
                          yypushback(1);
                          yybegin(NAME);
                        }
}

<NAME> {

    {name}              { System.out.println("<juicer>");
                          System.out.println("<name>" + yytext() + "</name>"); 
                        }

    {eol}               { yybegin(TYPE); }

    <<EOF>>             { System.out.println("</juicers>");
                          return 0; 
                        }

}

<TYPE> {

    {type}              { System.out.println("<type>" + yytext() + "</type>");  }

    {eol}               { yybegin(IMAGE); }

}

<IMAGE> {

    {image}             { System.out.println("<image>" + yytext() + "</image>");  }

    {eol}               { yybegin(DESCRIPTION); }

}

<DESCRIPTION> {

    {description}       { System.out.println("<description>" + yytext() + "</description>");  }

    {eol}               { yybegin(WARRANTY); }

}

<WARRANTY> {

    {warranty}          { System.out.println("<warranty>" + yytext() + "</warranty>"); }

    {eol}               { yybegin(WEIGHT); }
}

<WEIGHT> {

    {weight}            { System.out.println("<weight>" + yytext() + "</weight>"); }

    {eol}               { yybegin(COST); }
}

<COST> {

    {cost}              { System.out.println("<cost>" + yytext() + "</cost>"); }
 
    {eol}               { yybegin(RETAILER); }
}

<RETAILER> {

    {retailer}          { 
                          System.out.println("<retailer>" + yytext() + "</retailer>"); 
                          System.out.println("</juicer>");
                        }

    {eol}               { yybegin(NAME); }
}

