import java_cup.runtime.*;

%%

%class lex

%standalone

%unicode

LineTerminator = \r|\n|\r\n
XML_Declaration = "<?xml version="[\"']"1.0"[\"'][^\r\n]*"?>"{LineTerminator}
DOCTYPE_Declaration = "<!DOCTYPE "[^\r\n<>]+">"{LineTerminator}
Name = [^</>]+
StartTag = "<"{Name}">"
EndTag = "</"{Name}">"
PCDATA = [a-zA-Z0-9;& :,._()\"%\n\r\t-]+
Whitespace = [\n\r\t ]+

%%

{XML_Declaration}       { System.out.println("XML_DECLARATION"); }

{DOCTYPE_Declaration}   { System.out.println("DOCTYPE_DECLARATION"); }

{StartTag}              { String token = yytext();
                          if (token.equals("<juicers>")) System.out.println("JUICERS_ST");
                          else if (token.equals("<juicer>")) System.out.println("JUICER_ST");
                          else if (token.equals("<name>")) System.out.println("NAME_ST");
                          else if (token.equals("<type>")) System.out.println("TYPE_ST");
                          else if (token.equals("<image>")) System.out.println("IMAGE_ST");
                          else if (token.equals("<description>")) System.out.println("DESCRIPTION_ST");
                          else if (token.equals("<warranty>")) System.out.println("WARRANTY_ST");
                          else if (token.equals("<weight>")) System.out.println("WEIGHT_ST");
                          else if (token.equals("<cost>")) System.out.println("COST_ST");
                          else if (token.equals("<retailer>")) System.out.println("RETAILER_ST");
                        }

{EndTag}                { String token = yytext();
                          if (token.equals("</juicers>")) System.out.println("JUICERS_ET");
                          else if (token.equals("</juicer>")) System.out.println("JUICER_ET");
                          else if (token.equals("</name>")) System.out.println("NAME_ET");
                          else if (token.equals("</type>")) System.out.println("TYPE_ET");
                          else if (token.equals("</image>")) System.out.println("IMAGE_ET");
                          else if (token.equals("</description>")) System.out.println("DESCRIPTION_ET");
                          else if (token.equals("</warranty>")) System.out.println("WARRANTY_ET");
                          else if (token.equals("</weight>")) System.out.println("WEIGHT_ET");
                          else if (token.equals("</cost>")) System.out.println("COST_ET");
                          else if (token.equals("</retailer>")) System.out.println("RETAILER_ET");
                          else return 0; 
                        }

{Whitespace}            { ; }  /* Drop whitespace */

{PCDATA}                { System.out.println("PCDATA = " + yytext()); }

<<EOF>>                 { return 0; }
